StringBuilder (Java Card API, Connected Edition)
Date: 2009-12-11

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang
Class StringBuilder

    java.lang.Object
      java.lang.StringBuilder

    @TransactionType(value=SUPPORTS)
    public final class StringBuilder

extends Object

A mutable sequence of characters. This class provides an API compatible with `StringBuffer`, but with no guarantee of synchronization. This class is designed for use as a drop-in replacement for `StringBuffer` in places where the string buffer was being used by a single thread (as is generally the case). Where possible, it is recommended that this class be used in preference to `StringBuffer` as it will be faster under most implementations.

The principal operations on a `StringBuilder` are the `append` and `insert` methods, which are overloaded so as to accept data of any type. Each effectively converts a given datum to a string and then appends or inserts the characters of that string to the string builder. The `append` method always adds these characters at the end of the builder; the `insert` method adds the characters at a specified point.

For example, if `z` refers to a string builder object whose current contents are "`start`", then the method call `z.append("le")` would cause the string builder to contain "`startle`", whereas `z.insert(4, "le")` would alter the string builder to contain "`starlet`".

In general, if sb refers to an instance of a `StringBuilder`, then `sb.append(x)` has the same effect as `sb.insert(sb.length(), x)`. Every string builder has a capacity. As long as the length of the character sequence contained in the string builder does not exceed the capacity, it is not necessary to allocate a new internal buffer. If the internal buffer overflows, it is automatically made larger.

Instances of `StringBuilder` are not safe for use by multiple threads. If such synchronization is required then it is recommended that `StringBuffer` be used.

This Java Card class is a subset of the JDK 1.5 StringBuilder class. Some interfaces, methods and/or variables have been pruned, and/or other methods simplified, in an effort to reduce the size of this class and/or eliminate dependencies on unsupported features.

Since:
  JDK 1.5, Java Card 3.0
See Also:
  `StringBuffer`, `String`

Constructor Summary
`StringBuilder()` Constructs a string builder with no characters in it and an initial capacity of 16 characters.
`StringBuilder(int capacity)` Constructs a string builder with no characters in it and an initial capacity specified by the `capacity` argument.
`StringBuilder(String str)` Constructs a string builder initialized to the contents of the specified string.

Method Summary
`StringBuilder` | `append(boolean b)` Appends the string representation of the `boolean` argument to the sequence.
`StringBuilder` | `append(char c)` Appends the string representation of the `char` argument to this sequence.
`StringBuilder` | `append(char[] str)` Appends the string representation of the `char` array argument to this sequence.
`StringBuilder` | `append(char[] str, int offset, int len)` Appends the string representation of a subarray of the `char` array argument to this sequence.
`StringBuilder` | `append(int i)` Appends the string representation of the `int` argument to this sequence.
`StringBuilder` | `append(long l)` Appends the string representation of the `long` argument to this sequence.
`StringBuilder` | `append(Object obj)`
`StringBuilder` | `append(String str)` Appends the specified string to this character sequence.
`StringBuilder` | `append(StringBuffer sb)` Appends the specified `StringBuffer` to this sequence.
`int` | `capacity()` Returns the current capacity.
`char` | `charAt(int index)` Returns the `char` value in this sequence at the specified index.
`StringBuilder` | `delete(int start, int end)` Removes the characters in a substring of this sequence.
`StringBuilder` | `deleteCharAt(int index)` Removes the `char` at the specified position in this sequence.
`void` | `ensureCapacity(int minimumCapacity)` Ensures that the capacity is at least equal to the specified minimum.
`void` | `getChars(int srcBegin, int srcEnd, char[] dst, int dstBegin)` Characters are copied from this sequence into the destination character array `dst`.
`StringBuilder` | `insert(int offset, boolean b)` Inserts the string representation of the `boolean` argument into this sequence.
`StringBuilder` | `insert(int offset, char c)` Inserts the string representation of the `char` argument into this sequence.
`StringBuilder` | `insert(int offset, char[] str)` Inserts the string representation of the `char` array argument into this sequence.
`StringBuilder` | `insert(int index, char[] str, int offset, int len)` Inserts the string representation of a subarray of the `str` array argument into this sequence.
`StringBuilder` | `insert(int offset, int i)` Inserts the string representation of the second `int` argument into this sequence.
`StringBuilder` | `insert(int offset, long l)` Inserts the string representation of the `long` argument into this sequence.
`StringBuilder` | `insert(int offset, Object obj)` Inserts the string representation of the `Object` argument into this character sequence.
`StringBuilder` | `insert(int offset, String str)` Inserts the string into this character sequence.
`int` | `length()` Returns the length (character count).
`StringBuilder` | `replace(int start, int end, String str)` Replaces the characters in a substring of this sequence with characters in the specified `String`.
`StringBuilder` | `reverse()` Causes this character sequence to be replaced by the reverse of the sequence.
`void` | `setCharAt(int index, char ch)` The character at the specified index is set to `ch`.
`void` | `setLength(int newLength)` Sets the length of the character sequence.
`String` | `toString()` Returns a string representing the data in this sequence.
`void` | `trimToSize()` Attempts to reduce storage used for the character sequence.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### StringBuilder

    public StringBuilder()

  Constructs a string builder with no characters in it and an initial capacity of 16 characters.

### StringBuilder

    public StringBuilder(int capacity)

  Constructs a string builder with no characters in it and an initial capacity specified by the `capacity` argument.

  Parameters:
    `capacity` - the initial capacity.
  Throws:
    `NegativeArraySizeException` - if the `capacity` argument is less than `0`.

### StringBuilder

    public StringBuilder(String str)

  Constructs a string builder initialized to the contents of the specified string. The initial capacity of the string builder is `16` plus the length of the string argument.

  Parameters:
    `str` - the initial contents of the buffer.
  Throws:
    `NullPointerException` - if `str` is `null`

Method Detail

### length

    public int length()

  Returns the length (character count).

  Returns:
    the length of the sequence of characters currently represented by this object

### capacity

    public int capacity()

  Returns the current capacity. The capacity is the amount of storage available for newly inserted characters, beyond which an allocation will occur.

  Returns:
    the current capacity

### ensureCapacity

    public void ensureCapacity(int minimumCapacity)

  Ensures that the capacity is at least equal to the specified minimum. If the current capacity is less than the argument, then a new internal array is allocated with greater capacity. The new capacity is the larger of:
  - The `minimumCapacity` argument.
  - Twice the old capacity, plus `2`.
  If the `minimumCapacity` argument is nonpositive, this method takes no action and simply returns.

  Parameters:
    `minimumCapacity` - the minimum desired capacity.

### trimToSize

    public void trimToSize()

  Attempts to reduce storage used for the character sequence. If the buffer is larger than necessary to hold its current sequence of characters, then it may be resized to become more space efficient. Calling this method may, but is not required to, affect the value returned by a subsequent call to the `capacity()` method.

### setLength

    public void setLength(int newLength)

  Sets the length of the character sequence. The sequence is changed to a new character sequence whose length is specified by the argument. For every nonnegative index k less than `newLength`, the character at index k in the new character sequence is the same as the character at index k in the old sequence if k is less than the length of the old character sequence; otherwise, it is the null character `'\u0000'`. In other words, if the `newLength` argument is less than the current length, the length is changed to the specified length.

  If the `newLength` argument is greater than or equal to the current length, sufficient null characters (`'\u0000'`) are appended so that length becomes the `newLength` argument.

  The `newLength` argument must be greater than or equal to `0`.

  Parameters:
    `newLength` - the new length
  Throws:
    `IndexOutOfBoundsException` - if the `newLength` argument is negative.

### charAt

    public char charAt(int index)

  Returns the `char` value in this sequence at the specified index. The first `char` value is at index `0`, the next at index `1`, and so on, as in array indexing.

  The index argument must be greater than or equal to `0`, and less than the length of this sequence.

  Parameters:
    `index` - the index of the desired `char` value.
  Returns:
    the `char` value at the specified index.
  Throws:
    `IndexOutOfBoundsException` - if `index` is negative or greater than or equal to `length()`.

### getChars

    public void getChars(int srcBegin,
                         int srcEnd,
                         char[] dst,
                         int dstBegin)

  Characters are copied from this sequence into the destination character array `dst`. The first character to be copied is at index `srcBegin`; the last character to be copied is at index `srcEnd-1`. The total number of characters to be copied is `srcEnd-srcBegin`. The characters are copied into the subarray of `dst` starting at index `dstBegin` and ending at index:

  >      dstbegin + (srcEnd-srcBegin) - 1

  Parameters:
    `srcBegin` - start copying at this offset.
    `srcEnd` - stop copying at this offset.
    `dst` - the array to copy the data into.
    `dstBegin` - offset into `dst`.
  Throws:
    `NullPointerException` - if `dst` is `null`.
    `IndexOutOfBoundsException` - if any of the following is true:
    - `srcBegin` is negative
    - `dstBegin` is negative
    - the `srcBegin` argument is greater than the `srcEnd` argument.
    - `srcEnd` is greater than `this.length()`.
    - `dstBegin+srcEnd-srcBegin` is greater than `dst.length`

### setCharAt

    public void setCharAt(int index,
                          char ch)

  The character at the specified index is set to `ch`. This sequence is altered to represent a new character sequence that is identical to the old character sequence, except that it contains the character `ch` at position `index`.

  The index argument must be greater than or equal to `0`, and less than the length of this sequence.

  Parameters:
    `index` - the index of the character to modify.
    `ch` - the new character.
  Throws:
    `IndexOutOfBoundsException` - if `index` is negative or greater than or equal to `length()`.

### append

    public StringBuilder append(Object obj)

  See Also:
    `String.valueOf(java.lang.Object)`, `append(java.lang.String)`

### append

    public StringBuilder append(String str)

  Appends the specified string to this character sequence.

  The characters of the `String` argument are appended, in order, increasing the length of this sequence by the length of the argument. If `str` is `null`, then the four characters `"null"` are appended.

  Let n be the length of this character sequence just prior to execution of the `append` method. Then the character at index k in the new character sequence is equal to the character at index k in the old character sequence, if k is less than n; otherwise, it is equal to the character at index k-n in the argument `str`.

  Parameters:
    `str` - a string.
  Returns:
    a reference to this object.

### append

    public StringBuilder append(StringBuffer sb)

  Appends the specified `StringBuffer` to this sequence.

  The characters of the `StringBuffer` argument are appended, in order, to this sequence, increasing the length of this sequence by the length of the argument. If `sb` is `null`, then the four characters `"null"` are appended to this sequence.

  Let n be the length of this character sequence just prior to execution of the `append` method. Then the character at index k in the new character sequence is equal to the character at index k in the old character sequence, if k is less than n; otherwise, it is equal to the character at index k-n in the argument `sb`.

  Parameters:
    `sb` - the `StringBuffer` to append.
  Returns:
    a reference to this object.

### append

    public StringBuilder append(char[] str)

  Appends the string representation of the `char` array argument to this sequence.

  The characters of the array argument are appended, in order, to the contents of this sequence. The length of this sequence increases by the length of the argument.

  The overall effect is exactly as if the argument were converted to a string by the method `String.valueOf(char[])` and the characters of that string were then `appended` to this character sequence.

  Parameters:
    `str` - the characters to be appended.
  Returns:
    a reference to this object.

### append

    public StringBuilder append(char[] str,
                                int offset,
                                int len)

  Appends the string representation of a subarray of the `char` array argument to this sequence.

  Characters of the `char` array `str`, starting at index `offset`, are appended, in order, to the contents of this sequence. The length of this sequence increases by the value of `len`.

  The overall effect is exactly as if the arguments were converted to a string by the method `String.valueOf(char[],int,int)` and the characters of that string were then `appended` to this character sequence.

  Parameters:
    `str` - the characters to be appended.
    `offset` - the index of the first `char` to append.
    `len` - the number of `char`s to append.
  Returns:
    a reference to this object.

### append

    public StringBuilder append(boolean b)

  Appends the string representation of the `boolean` argument to the sequence.

  The argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then appended to this sequence.

  Parameters:
    `b` - a `boolean`.
  Returns:
    a reference to this object.

### append

    public StringBuilder append(char c)

  Appends the string representation of the `char` argument to this sequence.

  The argument is appended to the contents of this sequence. The length of this sequence increases by `1`.

  The overall effect is exactly as if the argument were converted to a string by the method `String.valueOf(char)` and the character in that string were then `appended` to this character sequence.

  Parameters:
    `c` - a `char`.
  Returns:
    a reference to this object.

### append

    public StringBuilder append(int i)

  Appends the string representation of the `int` argument to this sequence.

  The argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then appended to this sequence.

  Parameters:
    `i` - an `int`.
  Returns:
    a reference to this object.

### append

    public StringBuilder append(long l)

  Appends the string representation of the `long` argument to this sequence.

  The argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then appended to this sequence.

  Parameters:
    `l` - a `long`.
  Returns:
    a reference to this object.

### delete

    public StringBuilder delete(int start,
                                int end)

  Removes the characters in a substring of this sequence. The substring begins at the specified `start` and extends to the character at index `end - 1` or to the end of the sequence if no such character exists. If `start` is equal to `end`, no changes are made.

  Parameters:
    `start` - The beginning index, inclusive.
    `end` - The ending index, exclusive.
  Returns:
    This object.
  Throws:
    `StringIndexOutOfBoundsException` - if `start` is negative, greater than `length()`, or greater than `end`.

### deleteCharAt

    public StringBuilder deleteCharAt(int index)

  Removes the `char` at the specified position in this sequence. This sequence is shortened by one `char`.

  Note: If the character at the given index is a supplementary character, this method does not remove the entire character. If correct handling of supplementary characters is required, determine the number of `char`s to remove by calling `Character.charCount(thisSequence.codePointAt(index))`, where `thisSequence` is this sequence.

  Parameters:
    `index` - Index of `char` to remove
  Returns:
    This object.
  Throws:
    `StringIndexOutOfBoundsException` - if the `index` is negative or greater than or equal to `length()`.

### replace

    public StringBuilder replace(int start,
                                 int end,
                                 String str)

  Replaces the characters in a substring of this sequence with characters in the specified `String`. The substring begins at the specified `start` and extends to the character at index `end - 1` or to the end of the sequence if no such character exists. First the characters in the substring are removed and then the specified `String` is inserted at `start`. (This sequence will be lengthened to accommodate the specified String if necessary.)

  Parameters:
    `start` - The beginning index, inclusive.
    `end` - The ending index, exclusive.
    `str` - String that will replace previous contents.
  Returns:
    This object.
  Throws:
    `StringIndexOutOfBoundsException` - if `start` is negative, greater than `length()`, or greater than `end`.

### insert

    public StringBuilder insert(int index,
                                char[] str,
                                int offset,
                                int len)

  Inserts the string representation of a subarray of the `str` array argument into this sequence. The subarray begins at the specified `offset` and extends `len` `char`s. The characters of the subarray are inserted into this sequence at the position indicated by `index`. The length of this sequence increases by `len` `char`s.

  Parameters:
    `index` - position at which to insert subarray.
    `str` - A `char` array.
    `offset` - the index of the first `char` in subarray to be inserted.
    `len` - the number of `char`s in the subarray to be inserted.
  Returns:
    This object
  Throws:
    `StringIndexOutOfBoundsException` - if `index` is negative or greater than `length()`, or `offset` or `len` are negative, or `(offset+len)` is greater than `str.length`.

### insert

    public StringBuilder insert(int offset,
                                Object obj)

  Inserts the string representation of the `Object` argument into this character sequence.

  The second argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then inserted into this sequence at the indicated offset.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this sequence.

  Parameters:
    `offset` - the offset.
    `obj` - an `Object`.
  Returns:
    a reference to this object.
  Throws:
    `StringIndexOutOfBoundsException` - if the offset is invalid.

### insert

    public StringBuilder insert(int offset,
                                String str)

  Inserts the string into this character sequence.

  The characters of the `String` argument are inserted, in order, into this sequence at the indicated offset, moving up any characters originally above that position and increasing the length of this sequence by the length of the argument. If `str` is `null`, then the four characters `"null"` are inserted into this sequence.

  The character at index k in the new character sequence is equal to:

  - the character at index k in the old character sequence, if k is less than `offset`
  - the character at index k`-offset` in the argument `str`, if k is not less than `offset` but is less than `offset+str.length()`
  - the character at index k`-str.length()` in the old character sequence, if k is not less than `offset+str.length()`

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this sequence.

  Parameters:
    `offset` - the offset.
    `str` - a string.
  Returns:
    a reference to this object.
  Throws:
    `StringIndexOutOfBoundsException` - if the offset is invalid.

### insert

    public StringBuilder insert(int offset,
                                char[] str)

  Inserts the string representation of the `char` array argument into this sequence.

  The characters of the array argument are inserted into the contents of this sequence at the position indicated by `offset`. The length of this sequence increases by the length of the argument.

  The overall effect is exactly as if the argument were converted to a string by the method `String.valueOf(char[])` and the characters of that string were then `inserted` into this character sequence at the position indicated by `offset`.

  Parameters:
    `offset` - the offset.
    `str` - a character array.
  Returns:
    a reference to this object.
  Throws:
    `StringIndexOutOfBoundsException` - if the offset is invalid.

### insert

    public StringBuilder insert(int offset,
                                boolean b)

  Inserts the string representation of the `boolean` argument into this sequence.

  The second argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then inserted into this sequence at the indicated offset.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this sequence.

  Parameters:
    `offset` - the offset.
    `b` - a `boolean`.
  Returns:
    a reference to this object.
  Throws:
    `StringIndexOutOfBoundsException` - if the offset is invalid.

### insert

    public StringBuilder insert(int offset,
                                char c)

  Inserts the string representation of the `char` argument into this sequence.

  The second argument is inserted into the contents of this sequence at the position indicated by `offset`. The length of this sequence increases by one.

  The overall effect is exactly as if the argument were converted to a string by the method `String.valueOf(char)` and the character in that string were then `inserted` into this character sequence at the position indicated by `offset`.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this sequence.

  Parameters:
    `offset` - the offset.
    `c` - a `char`.
  Returns:
    a reference to this object.
  Throws:
    `IndexOutOfBoundsException` - if the offset is invalid.

### insert

    public StringBuilder insert(int offset,
                                int i)

  Inserts the string representation of the second `int` argument into this sequence.

  The second argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then inserted into this sequence at the indicated offset.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this sequence.

  Parameters:
    `offset` - the offset.
    `i` - an `int`.
  Returns:
    a reference to this object.
  Throws:
    `StringIndexOutOfBoundsException` - if the offset is invalid.

### insert

    public StringBuilder insert(int offset,
                                long l)

  Inserts the string representation of the `long` argument into this sequence.

  The second argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then inserted into this sequence at the position indicated by `offset`.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this sequence.

  Parameters:
    `offset` - the offset.
    `l` - a `long`.
  Returns:
    a reference to this object.
  Throws:
    `StringIndexOutOfBoundsException` - if the offset is invalid.

### reverse

    public StringBuilder reverse()

  Causes this character sequence to be replaced by the reverse of the sequence. Let n be the character length of this character sequence (not the length in `char` values) just prior to execution of the `reverse` method. Then the character at index k in the new character sequence is equal to the character at index n-k-1 in the old character sequence.

  Returns:
    a reference to this object.

### toString

    public String toString()

  Returns a string representing the data in this sequence. A new `String` object is allocated and initialized to contain the character sequence currently represented by this object. This `String` is then returned. Subsequent changes to this sequence do not affect the contents of the `String`.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this sequence of characters.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2009 Sun Microsystems, Inc. All rights reserved.